// GlpkSharp.h

#pragma once

extern "C" {
#include "glpk.h"

}

using namespace System;
using namespace System::Runtime::InteropServices;
namespace GlpkSharp {

	public enum class OptimisationDirection{
		MINIMISE=LPX_MIN,
		MAXIMISE=LPX_MAX
	};

	public enum class BOUNDSTYPE{
		Free=LPX_FR,
		Lower=LPX_LO,
		Upper=LPX_UP,
		Double=LPX_DB,
		Fixed=LPX_FX
	};

	public enum class BASESTATUS{
		Basic=LPX_BS,
		NonBasicLower=LPX_NL,
		NonBasicUpper=LPX_NU,
		NonBasicFree=LPX_NF,
		NonBasicFixed=LPX_NS
	};

	public enum class SOLVERSTATUS{
		Solved=LPX_E_OK,
		FaultyMatrix=LPX_E_FAULT,
		LowerBound=LPX_E_OBJLL,
		UpperBound=LPX_E_OBJUL,
		IterationLimit=LPX_E_ITLIM,
		TimeLimit=LPX_E_TMLIM,
		SolverFailure=LPX_E_SING,
		NoPrimalFeasible=LPX_E_NOPFS,
		NoDualFeasible=LPX_E_NODFS
	};
	public enum class SOLUTIONSTATUS{
		Optimal=LPX_OPT,
		Feasible=LPX_FEAS,
		Infeasible=LPX_INFEAS,
		NotFeasible=LPX_NOFEAS,
		Unbounded=LPX_UNBND,
		Undefined=LPX_UNDEF
	};
	public enum class WARMUP{
		OK=LPX_E_OK,
		EMPTY=LPX_E_EMPTY,
		BadBasis=LPX_E_BADB,
		Singular=LPX_E_SING
	};

	public enum class INTERIORSTATUS{
		Optimal=LPX_E_OK,
		Faulty=LPX_E_FAULT,
		NotFeasible=LPX_E_NOFEAS,
		NoConvergence=LPX_E_NOCONV,
		IterationLimit=LPX_E_ITLIM,
		Instable=LPX_E_INSTAB
	};
	public enum class MODELCLASS{
		LP=LPX_LP,
		MIP=LPX_MIP
	};
	public enum class COLKIND{
		Continuous=LPX_CV,
		Integer=LPX_IV
	};
	public enum class MIPSTATUS{
		Undefined=LPX_I_UNDEF,
		Optimal=LPX_I_OPT,
		Feasible=LPX_I_FEAS,
		NotFeasible=LPX_I_NOFEAS
	};

	public enum class INTEGERPARAM{
		MessageLevel=LPX_K_MSGLEV,
		Scale=LPX_K_SCALE,
		Dual=LPX_K_DUAL,
		Price=LPX_K_PRICE,
		Round=LPX_K_ROUND,
		IterationLimit=LPX_K_ITLIM,
		ITCNT=LPX_K_ITCNT,
		OUTFRQ=LPX_K_OUTFRQ,
		BRANCH=LPX_K_BRANCH,
		BTRACK=LPX_K_BTRACK,
		MPSINFO=LPX_K_MPSINFO,
		MPSOBJ=LPX_K_MPSOBJ,
		MPSORIG=LPX_K_MPSORIG,
		MPSWIDE=LPX_K_MPSWIDE,
		MPSFREE=LPX_K_MPSFREE,
		MPSSKIP=LPX_K_MPSSKIP,
		PRESOL=LPX_K_PRESOL,
		USECUTS=LPX_K_USECUTS
	};
	public enum class REALPARAM{
		Relax=LPX_K_RELAX,
		Tolerance=LPX_K_TOLBND,
		Toldj=LPX_K_TOLDJ,
		Tolpiv=LPX_K_TOLPIV,
		Objll=LPX_K_OBJLL,
		Objul=LPX_K_OBJUL,
		TMLIM=LPX_K_TMLIM,
		OutDelay=LPX_K_OUTDLY,
		TOLINT=LPX_K_TOLINT,
		TOLOBJ=LPX_K_TOLOBJ,
	};
	public enum class CUTS{
		COVER=LPX_C_COVER,
		CLIQUE=LPX_C_CLIQUE,
		GOMORY=LPX_C_GOMORY,
		ALL=LPX_C_ALL
	};

}
